import { mapStateToControlProps, rankWith } from '@jsonforms/core';
import { html } from '@microsoft/fast-element';
import { isDate } from '../testers/isDate';
import { DATE_CONTROL_RANK } from './RenderersRanks';
export const DateControlRendererTemplate = html `
  <template>
    <control-wrapper :control=${(x) => x.control} ?submitted=${(x) => x.submitted}>
      <zero-text-field
        :value=${(x) => {
    var _a, _b;
    return ((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.min) === undefined || ((_b = x.control.data) === null || _b === void 0 ? void 0 : _b.min) === null
        ? ''
        : new Intl.DateTimeFormat('fr-CA', {
            year: 'numeric',
            month: '2-digit',
            day: '2-digit',
        }).format(x.control.data.min);
}}
        @change="${(x, c) => {
    var _a, _b;
    const value = c.event.target.control.valueAsNumber;
    return x.control.handleChange(x.control.path, {
        min: value ? value : undefined,
        max: ((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.max) < value ? undefined : (_b = x.control.data) === null || _b === void 0 ? void 0 : _b.max,
        type: 'date',
    });
}}"
        id=${(x) => `min-${x.control.path}`}
        type="date"
        data-test-id=${(x) => `min-${x.control.path}`}
        @blur=${(x) => x.onBlur()}
        style="width: 100%"
      ></zero-text-field>
      <zero-text-field
        :value=${(x) => {
    var _a, _b;
    return ((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.max) === undefined || ((_b = x.control.data) === null || _b === void 0 ? void 0 : _b.max) === null
        ? ''
        : new Intl.DateTimeFormat('fr-CA', {
            year: 'numeric',
            month: '2-digit',
            day: '2-digit',
        }).format(x.control.data.max);
}}
        @change="${(x, c) => {
    var _a, _b;
    const value = c.event.target.control.valueAsNumber;
    return x.control.handleChange(x.control.path, {
        min: ((_a = x.control.data) === null || _a === void 0 ? void 0 : _a.min) > value ? undefined : (_b = x.control.data) === null || _b === void 0 ? void 0 : _b.min,
        max: value ? value : undefined,
        type: 'date',
    });
}}"
        id=${(x) => `max-${x.control.path}`}
        type="date"
        data-test-id=${(x) => `max-${x.control.path}`}
        @blur=${(x) => x.onBlur()}
        style="width: 100%"
      ></zero-text-field>
    </control-wrapper>
  </template>
`;
export const FilterDateControlRendererEntry = {
    renderer: DateControlRendererTemplate,
    tester: rankWith(DATE_CONTROL_RANK, isDate),
    mapper: mapStateToControlProps, // TODO: change mapper to handle dates instead of doing it in the template
};
